
import inet.networklayer.configurator.ipv4.Ipv4NetworkConfigurator;
import inet.networklayer.ipv4.RoutingTableRecorder;
import inet.node.ethernet.Eth10G;
import inet.node.inet.Router;
import inet.node.inet.StandardHost;
import simu5g.common.binder.Binder;
import simu5g.common.carrierAggregation.CarrierAggregation;
import simu5g.nodes.Upf;
import simu5g.nodes.NR.gNodeB;
import simu5g.nodes.NR.NRUe;
import simu5g.nodes.backgroundCell.BackgroundCell;
import simu5g.world.radio.LteChannelControl;

network MultiCell_Standalone
{
    parameters:
        int numUe = default(1);
        int numBgCells = default(0);
        @display("i=block/network2;bgb=1088.032,678.896;bgi=background/pisa");
    submodules:
        channelControl: LteChannelControl {
            @display("p=50,25;is=s");
        }
        routingRecorder: RoutingTableRecorder {
            @display("p=50,75;is=s");
        }
        configurator: Ipv4NetworkConfigurator {
            @display("p=50,125");
        }
        binder: Binder {
            @display("p=50,175;is=s");
        }
        carrierAggregation: CarrierAggregation {
            @display("p=50.993748,258.7;is=s");
        }
        server: StandardHost {
            @display("p=212,118;is=n;i=device/server");
        }
        router: Router {
            @display("p=351.81198,115.771996;i=device/smallrouter");
        }
        upf: Upf {
            @display("p=500,115");
        }
        iUpf: Upf {
            @display("p=500,215");
        }
    
        gnb0: gNodeB {
            @display("p=250,300;is=vl");
        }
            
        gnb1: gNodeB {
            @display("p=250,300;is=vl");
        }
            
        gnb2: gNodeB {
            @display("p=250,300;is=vl");
        }
            
        gnb3: gNodeB {
            @display("p=250,300;is=vl");
        }
            
        gnb4: gNodeB {
            @display("p=250,300;is=vl");
        }
            
        gnb5: gNodeB {
            @display("p=250,300;is=vl");
        }
            
        gnb6: gNodeB {
            @display("p=250,300;is=vl");
        }
            
        gnb7: gNodeB {
            @display("p=250,300;is=vl");
        }
            
        gnb8: gNodeB {
            @display("p=250,300;is=vl");
        }
            
        gnb9: gNodeB {
            @display("p=250,300;is=vl");
        }
            
        gnb10: gNodeB {
            @display("p=250,300;is=vl");
        }
            
        gnb11: gNodeB {
            @display("p=250,300;is=vl");
        }
            
        bgCell[numBgCells]: BackgroundCell {
            @display("p=249.528,483.31998;is=vl");
        }
        ue[numUe]: NRUe {
            @display("p=499.056,428.244");
        }
    connections:

        //# Data Network connections
        server.pppg++ <--> Eth10G <--> router.pppg++;
        router.pppg++ <--> Eth10G <--> upf.filterGate;

        //# 5G Core Network connections
        upf.pppg++ <--> Eth10G <--> iUpf.pppg++;
            
        iUpf.pppg++ <--> Eth10G <--> gnb0.ppp;
    
        iUpf.pppg++ <--> Eth10G <--> gnb1.ppp;
    
        iUpf.pppg++ <--> Eth10G <--> gnb2.ppp;
    
        iUpf.pppg++ <--> Eth10G <--> gnb3.ppp;
    
        iUpf.pppg++ <--> Eth10G <--> gnb4.ppp;
    
        iUpf.pppg++ <--> Eth10G <--> gnb5.ppp;
    
        iUpf.pppg++ <--> Eth10G <--> gnb6.ppp;
    
        iUpf.pppg++ <--> Eth10G <--> gnb7.ppp;
    
        iUpf.pppg++ <--> Eth10G <--> gnb8.ppp;
    
        iUpf.pppg++ <--> Eth10G <--> gnb9.ppp;
    
        iUpf.pppg++ <--> Eth10G <--> gnb10.ppp;
    
        iUpf.pppg++ <--> Eth10G <--> gnb11.ppp;
    
        gnb0.x2++ <--> Eth10G <--> gnb1.x2++;
        
        gnb1.x2++ <--> Eth10G <--> gnb2.x2++;
        
        gnb2.x2++ <--> Eth10G <--> gnb3.x2++;
        
        gnb3.x2++ <--> Eth10G <--> gnb4.x2++;
        
        gnb4.x2++ <--> Eth10G <--> gnb5.x2++;
        
        gnb5.x2++ <--> Eth10G <--> gnb6.x2++;
        
        gnb6.x2++ <--> Eth10G <--> gnb7.x2++;
        
        gnb7.x2++ <--> Eth10G <--> gnb8.x2++;
        
        gnb8.x2++ <--> Eth10G <--> gnb9.x2++;
        
        gnb9.x2++ <--> Eth10G <--> gnb10.x2++;
        
        gnb10.x2++ <--> Eth10G <--> gnb11.x2++;
        
        gnb11.x2++ <--> Eth10G <--> gnb0.x2++;
        }